-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- settings.lua

function loadSettings()
	-- load settings ugly.
	statement = "SELECT _system_fullscreen, _system_resx, _system_resy, _system_shadows, _system_vsynch, _system_camtype, _system_camspeed, _system_sfx, _system_music  "
	statement = statement .. " FROM _system "
	statement = statement .. " WHERE _system_id = 1 "
	print( statement )
	local q = sql:exe( statement )
	if q == nil then return end
	if tonumber( q:getData( 0 ) ) == 0 then fs = false else fs = true end
	screen_width = tonumber( q:getData( 1 ) )
	screen_height = tonumber( q:getData( 2 ) )
	if tonumber( q:getData( 3 ) ) == 0 then sh = false else sh = true end	
	if tonumber( q:getData( 4 ) ) == 0 then vsynch = false else vsynch = true end		

	cam_type = tonumber( q:getData( 5 ) )
	cam_speed = tonumber( q:getData( 6 ) )
	sound_sfx_vol = tonumber( q:getData( 7 ) )
	sound_music_vol = tonumber( q:getData( 8 ) )
	
	sql:removeResult(q)
end

function loadStyle()
-- set up some skin colours
	drkgrey  = xcore.xcolour(255, 50, 50, 50)	
	grey  = xcore.xcolour(255, 196, 196, 196)
	ltgrey = xcore.xcolour(255, 222, 222, 222)
	white = xcore.xcolour(255, 255, 255, 255)
	black = xcore.xcolour(255, 0, 0, 0)
	clear = xcore.xcolour(0, 0, 0, 0)
	red = xcore.xcolour(255, 255, 0, 0)
	green = xcore.xcolour(255, 0, 255, 0)
	blue = xcore.xcolour(255, 0, 0, 255)


	-- sim:setColour( drkgrey )
	sim:setSkinColor( xcore.XGDC_3D_FACE,  clear )
	sim:setSkinColor( xcore.XGDC_3D_SHADOW,  clear )
	sim:setSkinColor( xcore.XGDC_3D_DARK_SHADOW,  clear )
	sim:setSkinColor( xcore.XGDC_3D_LIGHT,  clear )

	sim:setSkinColor( xcore.XGDC_ACTIVE_CAPTION,  white )
	sim:setSkinColor( xcore.XGDC_INACTIVE_BORDER,  white )

	-- sim:setSkinColor( xcore.XGDC_BUTTON_TEXT,black )
	sim:setSkinColor( xcore.XGDC_GRAY_TEXT,  white )
	sim:setSkinColor( xcore.XGDC_WINDOW,  clear )
	sim:setSkinColor( xcore.XGDC_WINDOW_SYMBOL, clear )

	-- sim:setSkinColor( xcore.XGDC_HIGH_LIGHT,  clear )
	sim:setSkinColor( xcore.XGDC_ICON,  white )
	sim:setSkinColor( xcore.XGDC_ICON_HIGH_LIGHT,  clear )

	sim:setSkinColor( xcore.XGDC_HIGH_LIGHT,  white )
	sim:setSkinColor( xcore.XGDC_HIGH_LIGHT_TEXT,  grey )
	sim:setSkinColor( xcore.XGDC_SCROLLBAR,  white )
	--[[ ]]--
	
	-- fonts too

	--[[
	XGDC_3D_DARK_SHADOW,
	XGDC_3D_SHADOW,
	XGDC_3D_FACE,
	XGDC_3D_LIGHT,
	XGDC_ACTIVE_BORDER,
	XGDC_ACTIVE_CAPTION,
	XGDC_APP_WORKSPACE,
	XGDC_BUTTON_TEXT,
	XGDC_GRAY_TEXT,
	XGDC_HIGH_LIGHT,
	XGDC_HIGH_LIGHT_TEXT,
	XGDC_INACTIVE_BORDER,
	XGDC_INACTIVE_CAPTION,
	XGDC_TOOLTIP,
	XGDC_TOOLTIP_BACKGROUND,
	XGDC_SCROLLBAR,
	XGDC_WINDOW,
	XGDC_WINDOW_SYMBOL,
	XGDC_ICON,
	XGDC_ICON_HIGH_LIGHT,
	--]]
end

function loadSounds()
	print("[settings] load sounds")
	snd:clear()

	sound_menu_theme = snd:addOGGSample( path .. "resources/audio/theme_menu.ogg", sound_music_vol*0.01 )
	sound_dungeon_theme = snd:addOGGSample( path .. "resources/audio/theme_dungeon.ogg", sound_music_vol*0.01 )

	sound_cast = snd:addOGGSample ( path .. "resources/audio/cast.ogg", sound_sfx_vol*0.01 )	
	sound_hit = snd:addOGGSample ( path .. "resources/audio/hit.ogg", sound_sfx_vol*0.01 )	
	sound_attack = snd:addWAVSample ( path .. "resources/audio/attack.wav", false, sound_sfx_vol*0.01 )	
	sound_loot = snd:addWAVSample ( path .. "resources/audio/loot.wav", false, sound_sfx_vol*0.01 )
	sound_win = snd:addWAVSample ( path .. "resources/audio/win.wav", false, sound_sfx_vol*0.01 )
	sound_lose = snd:addWAVSample ( path .. "resources/audio/lose.wav", false, sound_sfx_vol*0.01 )
	-- sound_hurt = snd:addWAVSample ( path .. "resources/audio/hurt.wav", false, sound_sfx_vol*0.01 )
end


function updateSoundLevels()
	print("[settings] updateSoundLevels")

	snd:setSourceGain ( sound_menu_theme, sound_music_vol*0.01 )
	snd:setSourceGain ( sound_dungeon_theme, sound_music_vol*0.01 )

	snd:setSourceGain ( sound_cast, sound_sfx_vol*0.01 )	
	snd:setSourceGain ( sound_hit, sound_sfx_vol*0.01 )	
	snd:setSourceGain ( sound_attack, sound_sfx_vol*0.01 )	
	snd:setSourceGain ( sound_loot, sound_sfx_vol*0.01 )	
	snd:setSourceGain ( sound_win, sound_sfx_vol*0.01 )	
	snd:setSourceGain ( sound_lose, sound_sfx_vol*0.01 )	
end

