-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- state_scores.lua

state_scores = state:new()

-- print "[state_scores]"

-- creation
function state_scores:new (o)
	-- print "[state_scores] new state_scores"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	self.sid = 0

	width = 512
	height = 256	
	btn_w = 200
	btn_h = 40
	x = screen_width/2-(width/2)
	y = screen_height/2 -(height/2)

	text = ""
	text_scores = sim:addText( 0, text, x, y, x+width, y+height)
	text_scores:setVisible( false )
	text_scores:setAlignment( 2, 0 )
	
	btn_w = 200
	btn_h = 40
	
	x = screen_width/2-(btn_w/2)
	y = screen_height-100
	-- add some buttons
	button_scores_exit = sim:addButton( 901, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Back" )
	button_scores_exit:setVisible( false )
	button_scores_exit:setImage( button_texture )
	button_scores_exit:setPressedImage( button_pressed_texture )
	
	-- bind events to actions.
	sim:bindGUI ( "button_scores_exit_pressed", 901, xcore.XGUI_BUTTON_CLICKED )

	return o
end

-- called on state_scores enter
function state_scores:enter ()
	-- print "[state_scores] enter state_scores"
	if dungeon_level > 0 then
		-- print("Show summery")	
		self:hideList()
	else
		-- print("Show List")
		-- enter data into high score list
		self:showList()
	end
end

function state_scores:hideList()
	text_scores:setVisible( false )
	button_scores_exit:setVisible( false )
	text_title:setVisible( false )
	text_title:setText( "High Scores" )
	image_background_title:setVisible( false )
	
end

function state_scores:showList()
	-- print("[state_scores] showList")
	text_scores:setVisible( true )
	button_scores_exit:setVisible( true )
	text_title:setVisible( true )
	text_title:setText( "High Scores" )
	image_background_title:setVisible( true )

	
	statement = "SELECT score_name, score_total, score_level, score_depth "
	statement = statement .. " FROM table_scores "
	statement = statement .. " ORDER BY score_total DESC "
	statement = statement .. " LIMIT 20 "	
	q = sql:exe( statement )
	
	text = ""
	if q ~= nil then
		-- print ("returned " .. q:getRowCount() .. " rows ")		
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
			local name = q:getData( n+0 )
			local total = tonumber( q:getData( n+1 ) )
			local level = tonumber( q:getData( n+2 ) )
			local depth = tonumber(  q:getData( n+3 ) )
			if level < depth then
				-- print("died")
				text = text .. name .. " died on level " .. level .. " with " .. total .. " points.\n"
			else
				-- print("cleared")
				text = text .. name .. " cleared level " .. level .. " with " .. total .. " points.\n"
			end
		end
		sql:removeResult( q )			
	else
		-- print("no data avaliable")
	end
	text_scores:setText( text )
end

-- called on state_scores exit
function state_scores:exit ()
	-- print "[state_scores] exit state_scores"
	text_scores:setVisible( false )
	button_scores_exit:setVisible( false )
	self:hideList()
	dungeon_level = 0
end

-- called to advance state_scores
function state_scores:input ()
	-- self.time = self.time + 1
	sim:update()
	if sim:isKey( "key_pressed_exit_state" ) then return ENUM_MENU end
	if sim:isGUI( "button_scores_exit_pressed" ) then return ENUM_MENU end
	if sim:isGUI( "button_summary_accept_pressed" ) then
		print "[state_game] record score in the hall of fame!"
		if score_total > 0 then
			statement = "INSERT INTO table_scores"
			statement = statement .. " ( score_name, score_level, score_depth, score_total ) "
			statement = statement .. " VALUES ( '".. editbox_select_names[1]:getText() .. "', "
			statement = statement .. dungeon_level .. ", " .. map_depth .. ", " .. score_total  .." )"
			print( statement )
			sql:exe( statement )
		end
		menu_summary:hide()
		self:showList()
	end
	return ENUM_SCORES 
end

-- called when changing state_scores
function state_scores:transition ( i ) -- transition to state_scores v
end
